//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * WFCUԎ
 * @author Junpee
 */

#include "Core/Utility/stdafx.h"
#include "Enemy/Gelaim/GelaimAttackState.h"
#include "Game/Sound/SoundSystem.h"
#include "Enemy/System/Enemy.h"
#include "Stage/System/Stage.h"

#include "Enemy/Gelaim/GelaimStandState.h"
#include "Enemy/Gelaim/GelaimRunState.h"

//------------------------------------------------------------------------------
// Aj
//------------------------------------------------------------------------------
// RXgN^
GelaimAttackState::GelaimAttackState(Gelaim* gelaim) : GelaimState(gelaim){
}
//------------------------------------------------------------------------------
// fXgN^
GelaimAttackState::~GelaimAttackState(){
}
//------------------------------------------------------------------------------
// s
//------------------------------------------------------------------------------
// 
void GelaimAttackState::initialize(){
	// Aj[VV[PXݒ
	getAnimation()->setSequence(2);
	// U炷
	getSoundSystem()->play("GelaimAttack");
}
//------------------------------------------------------------------------------
// n
void GelaimAttackState::finalize(){
	// RW𖳌ɖ߂
	getAttackCollision()->setEnabled(false);
}
//------------------------------------------------------------------------------
// s
void GelaimAttackState::run(){
	// 萔
	float animationScale = 1.f;
	float moveXZScale = 0.01f;

	// Xe[gύX
	if(!isDamaged()){
		if(getRunCounter() == 60){
			getEnemy()->setState(new GelaimStandState(getGelaim()));
		}
	}

	// ʒuƑx̌vZ
	calcVelocityAndPosition();
	// ̐ݒ
	setDirection(getPlayerDirection());

	// n`RW
	landCollide();

	// `ZbgAbv
	drawSetup(animationScale);

	// U
	if(getRunCounter() == 20){ getAttackCollision()->setEnabled(true); }
	if(getRunCounter() == 30){ getAttackCollision()->setEnabled(false); }
	if(getAttackCollision()->isEnabled()){
		attackCollide(getAttackBone(), Vector3(5.f, 0.f, 5.f), 5.f, 30);
	}

}
//------------------------------------------------------------------------------
