//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * Xt@CRo[^wb_
 * @author Junpee
 */

#ifndef X_FILE_CONVERTER_H_
#define X_FILE_CONVERTER_H_

#include <Framework/System/BasicFramework.h>

// Lamp̃l[Xy[XLɂ
using namespace Lamp;

namespace Lamp{
class Renderer;
class Scene;
class Camera;
class PointLight;
class DirectionalLight;
class PS2PadCameraController;
}

//------------------------------------------------------------------------------
/**
 * Xt@CRo[^
 */
class XFileConverter : public BasicFramework{
public:
	/**
	 * RXgN^
	 * @param command R}h
	 */
	XFileConverter(const String& command);

	/**
	 * fXgN^
	 */
	virtual ~XFileConverter();

protected:
	//--------------------------------------------------------------------------
	// t[[N\bh
	//--------------------------------------------------------------------------
	/**
	 * 
	 * @return ɐtrueԂ
	 */
	virtual bool initialize();

	/**
	 * n
	 */
	virtual void finalize();

	/**
	 * s
	 */
	virtual void run();

	/**
	 * _O
	 */
	virtual void renderSetup();

	/**
	 * _O
	 */
	virtual void render();

	/**
	 * `
	 */
	virtual void drawInformation();

private:
	//--------------------------------------------------------------------------
	// R}h
	String command_;
	// _
	Renderer* renderer_;
	// V[
	Scene* scene_;
	// J
	Camera* camera_;
	// |CgCg
	PointLight* pointLight_;
	// fBNViCg
	DirectionalLight* directionalLight_;
	// JRg[
	PS2PadCameraController* cameraController_;

};

//------------------------------------------------------------------------------
#endif // End of X_FILE_CONVERTER_H_
//------------------------------------------------------------------------------
